/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/

/*
 *@Note
  Uļϵͳ̣
  USBHDM(PA11)USBHDP(PA12)
  ʾ Uļϵͳ,Ŀ¼ɾĿ¼
  עļϵͳ֧ FAT12/FAT16/FAT32
  CH559EVT EXAM9ֲֲһע㡣
 CH559vSectorSizeH CH559бʾ2
 CH32V103 CH559vSectorSizeʾ512
 עϵת䡣

*/

#include "debug.h"
#include "string.h"
#include "CHRV3UFI.h"

/* Global define */


/* Global Variable */
__attribute__ ((aligned(4))) UINT8  RxBuffer[MAX_PACKET_SIZE] ;      // IN, must even address
__attribute__ ((aligned(4))) UINT8  TxBuffer[MAX_PACKET_SIZE] ;      // OUT, must even address
__attribute__ ((aligned(4))) UINT8  Com_Buffer[128];

/* ״̬,ʾ벢ͣ */
void mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
      return;    /* ɹ */
    }
    printf( "Error: %02X\r\n", (UINT16)iError );  /* ʾ */
    /* ,Ӧ÷ԼCHRV3DiskStatus״̬,CHRV3DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
       Ĵ:
       1һCHRV3DiskReady,ɹ,Open,Read/Write
       2CHRV3DiskReadyɹ,ôǿнͷʼ(ȴUӣCHRV3DiskReady) */
    while ( 1 )
    {  }
}

/*******************************************************************************
* Function Name  : Set_USBConfig
* Description    : Set USB clock.
* Input          : None
* Return         : None
*******************************************************************************/
void USBHD_ClockCmd(UINT32 RCC_USBCLKSource,FunctionalState NewState)
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, NewState);
	EXTEN->EXTEN_CTR |= EXTEN_USBHD_IO_EN;
	RCC_USBCLKConfig(RCC_USBCLKSource);             //USBclk=PLLclk/1.5=48Mhz
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_USBHD,NewState);
}

typedef struct __PACKED _LONG_NAME{		//ֽڶ
	UINT8  LDIR_Ord ;		/*ļţΪ0X40ʾһ*/
	UINT16  LDIR_Name1[5];		/*ļǰ5ֽ*/
	UINT8  LDIR_Attr;		/*ԱΪATTR_LONG_NAME*/
	UINT8  LDIR_Type;		/* Ϊ0ʾļ*/
	UINT8  LDIR_Chksum;		/*ļУ*/
	UINT16  LDIR_Name2[6];		/*ļ6-11ַ*/
	UINT8  LDIR_FstClusLO[2];	/*Ϊ0*/
	UINT16  LDIR_Name3[2];		/*ļ12-13ԡַ*/

} F_LONG_NAME;				/*峤ļ*/

typedef F_LONG_NAME *P_LONG_NAME;
#define MAX_LONG_NAME  4
#define FILE_LONG_NAME    MAX_LONG_NAME*13+1
#define DATA_BASE_BUF_LEN     512

UINT8	DATA_BASE_BUF0[ DATA_BASE_BUF_LEN ];
UINT8	DATA_BASE_BUF1[ DATA_BASE_BUF_LEN ];

UINT16 LongFileName[FILE_LONG_NAME];	/*ļռֻ洢ļ·*/


/*******************************************************************************
* Function Name  : CreateDirectory
* Description    : ½Ŀ¼,Ŀ¼ѾֱӴ򿪣Ŀ¼mCmdParam.Create.mPathName,ļͬ
* Input          :
* Output         : None
* Return         : ERR_SUCCESS = Ŀ¼ɹߴĿ¼ɹ,
                   ERR_FOUND_NAME = Ѿͬļ,
                   ERR_MISS_DIR = ·ЧϼĿ¼
*******************************************************************************/
UINT8   CreateDirectory( void )
{
    UINT8   i, j;
    UINT32  UpDirCluster;
    PUINT8 DirXramBuf;
    UINT8  *DirConstData;
    j = 0xFF;
    for ( i = 0; i != sizeof( mCmdParam.Create.mPathName ); i ++ )    //Ŀ¼·
    {
        if ( mCmdParam.Create.mPathName[ i ] == 0 )
        {
            break;
        }
        if ( mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR1 || mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR2 )
        {
            j = i;                                                     //¼ϼĿ¼
        }
    }

    i = ERR_SUCCESS;
    if ( j == 0 || j == 2 && mCmdParam.Create.mPathName[1] == ':' )
       {
           UpDirCluster = 0;                                              //ڸĿ¼´Ŀ¼
       }
    else
    {
        if ( j != 0xFF )                                               //ھ·ӦûȡϼĿ¼ʼغ
        {
            mCmdParam.Create.mPathName[ j ] = 0;
            i = CHRV3FileOpen( );
            if ( i == ERR_SUCCESS )
            {
                i = ERR_MISS_DIR;                                      //ļĿ¼
            }
            else if ( i == ERR_OPEN_DIR )
            {
                i = ERR_SUCCESS;                                       //ɹϼĿ¼
            }
            mCmdParam.Create.mPathName[ j ] = PATH_SEPAR_CHAR1;        //ָĿ¼ָ
        }
        UpDirCluster = CHRV3vStartCluster;                             //ϼĿ¼ʼغ
    }
    if ( i == ERR_SUCCESS )                                            //ɹȡϼĿ¼ʼغ
    {
        i = CHRV3FileOpen( );
        if ( i == ERR_SUCCESS )
        {
            i = ERR_FOUND_NAME;                                        //ļĿ¼
        }
        else if ( i == ERR_OPEN_DIR )
        {
            i = ERR_SUCCESS;                                           //Ŀ¼Ѿ
        }
        else if ( i == ERR_MISS_FILE )                                 //Ŀ¼,½
        {
            i = CHRV3FileCreate( );
            if ( i == ERR_SUCCESS )
            {
                if ( pDISK_FAT_BUF == pDISK_BASE_BUF )
                {
                    memset(pDISK_FAT_BUF,0,0x200);     //FILE_DATA_BUFDISK_BASE_BUF̻
                }
                DirXramBuf = pDISK_FAT_BUF;                            //ļݻ
                DirConstData = ".          \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0..         \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0";
                for ( i = 0x40; i != 0; i -- )                         //Ŀ¼ıԪ,ֱָϼĿ¼
                {
                    *DirXramBuf = *DirConstData;
                    DirXramBuf ++;
                    DirConstData ++;
                }
                *(pDISK_FAT_BUF+0x1A) = ( (PUINT8)&CHRV3vStartCluster )[3];//ʼغ
                *(pDISK_FAT_BUF+0x1B) = ( (PUINT8)&CHRV3vStartCluster )[2];
                *(pDISK_FAT_BUF+0x14) = ( (PUINT8)&CHRV3vStartCluster )[1];
                *(pDISK_FAT_BUF+0x15) = ( (PUINT8)&CHRV3vStartCluster )[0];
                *(pDISK_FAT_BUF+0x20+0x1A) = ( (PUINT8)&UpDirCluster )[3];//ϼĿ¼ʼغ
                *(pDISK_FAT_BUF+0x20+0x1B) = ( (PUINT8)&UpDirCluster )[2];
                *(pDISK_FAT_BUF+0x20+0x14) = ( (PUINT8)&UpDirCluster )[1];
                *(pDISK_FAT_BUF+0x20+0x15) = ( (PUINT8)&UpDirCluster )[0];
//              for ( count = 0x40; count != CH559vSectorSizeH*256; count ++ ) {  /* Ŀ¼ʣಿ */
//                  *DirXramBuf = 0;
//                  DirXramBuf ++;
//              }
                mCmdParam.Write.mSectorCount = 1;
                mCmdParam.Write.mDataBuffer = pDISK_FAT_BUF;                //ָļݻʼַ
                i = CHRV3FileWrite( );
                if ( i == ERR_SUCCESS )
                {
                    DirXramBuf = pDISK_FAT_BUF;
                    for ( i = 0x40; i != 0; i -- )                          //Ŀ¼
                    {
                        *DirXramBuf = 0;
                        DirXramBuf ++;
                    }
                    for ( j = 1; j != CHRV3vSecPerClus; j ++ )
                    {
                        if ( pDISK_FAT_BUF == pDISK_BASE_BUF )
                        {
                            memset(pDISK_FAT_BUF,0,0x200);   //FILE_DATA_BUFDISK_BASE_BUF̻
                        }
                        mCmdParam.Write.mSectorCount = 1;
                        mCmdParam.Write.mDataBuffer = pDISK_FAT_BUF;         //ָļݻʼַ
                        i = CHRV3FileWrite( );                               //Ŀ¼ʣ
                        if ( i != ERR_SUCCESS )
                        {
                            break;
                        }
                    }
                    if ( j == CHRV3vSecPerClus )                              //ɹĿ¼
                    {
                        mCmdParam.Modify.mFileSize = 0;                       //Ŀ¼ĳ0
                        mCmdParam.Modify.mFileDate = 0xFFFF;
                        mCmdParam.Modify.mFileTime = 0xFFFF;
                        mCmdParam.Modify.mFileAttr = 0x10;                    //Ŀ¼
                        i = CHRV3FileModify( );                               //ļϢ޸ΪĿ¼
                    }
                }
            }
        }
    }
    return( i );
}
/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main()
{
	UINT8   s, i;
	 UINT8  buf[100];
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
  Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);

	printf("USBHD   HOST Test\r\n");
	USBHD_ClockCmd(RCC_USBCLKSource_PLLCLK_1Div5,ENABLE);
	pHOST_RX_RAM_Addr = RxBuffer;
	pHOST_TX_RAM_Addr = TxBuffer;
	USB_HostInit();
	CHRV3LibInit();
	printf( "Wait Device In\r\n" );

	while(1)
	{
		s = ERR_SUCCESS;

		if ( R8_USB_INT_FG & RB_UIF_DETECT )
		{
			R8_USB_INT_FG = RB_UIF_DETECT ;

			s = AnalyzeRootHub( );
			if ( s == ERR_USB_CONNECT )
			{
				printf( "New Device In\r\n" );
				FoundNewDev = 1;
			}
			if( s == ERR_USB_DISCON )
			{
				printf( "Device Out\r\n" );
			}
		}

		if ( FoundNewDev || s == ERR_USB_CONNECT )
		{
			FoundNewDev = 0;
			Delay_Ms( 200 );
			s = InitRootDevice( Com_Buffer );
			if ( s == ERR_SUCCESS )
			{
				// U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CHRV3ӳɺ
				CHRV3DiskStatus = DISK_USB_ADDR;
				for ( i = 0; i != 10; i ++ )
				{
					printf( "Wait DiskReady\n" );
					s = CHRV3DiskReady( );                                 //ȴU׼
					if ( s == ERR_SUCCESS )
					{
						break;
					}
					else
					{
						printf("%02x\r\n",(UINT16)s);
					}
					Delay_Ms( 50 );
				}
				if ( CHRV3DiskStatus >= DISK_MOUNTED )
				{
				    printf( "Create Level 1 Directory /YEAR2004 \n" );
                      strcpy( mCmdParam.Create.mPathName, "/YEAR2004" );           //Ŀ¼,Ŀ¼ڸĿ¼
                      i = CreateDirectory( );                                      //½ߴĿ¼
                      mStopIfError( i );
                      /* Ŀ¼½ߴ򿪳ɹ,Ŀ¼½һʾļ */
                      printf( "Create New File /YEAR2004/DEMO2004.TXT \n" );
                      strcpy( mCmdParam.Create.mPathName, "/YEAR2004/DEMO2004.TXT" );//ļ
                      i = CHRV3FileCreate( );                                       //½ļ,ļѾɾ½
                      mStopIfError( i );
                      printf( "Write some data to file DEMO2004.TXT \n" );
                      i = sprintf( buf, "ʾļ\xd\xa" );
                      mCmdParam.ByteWrite.mByteCount = i;                           //ָдֽ,ζдĳȲܳMAX_BYTE_IO
                      mCmdParam.ByteWrite.mByteBuffer = buf;                        //ָ򻺳
                      i = CHRV3ByteWrite( );                                        //ֽΪλļд,ζдĳȲܳMAX_BYTE_IO
                      mStopIfError( i );
                      printf( "Close file DEMO2004.TXT \n" );
                      mCmdParam.Close.mUpdateLen = 1;                               //Զļ,ֽΪλдļ,óرļԱԶļ
                      i = CHRV3FileClose( );
				    //ɾĿ¼ļĲ
				    /*
                    printf( "Erase\n" );
                    strcpy( (PCHAR)mCmdParam.Open.mPathName, "/YEAR2005" );     //ýҪļ·ļ/C51/NEWFILE.C
                    s = CHRV3FileOpen( );
                    strcpy( (PCHAR)mCmdParam.Create.mPathName, "/YEAR2005" );  //ɾļ,ڸĿ¼
                    i = CHRV3FileErase( );  //ɾļر
                    if ( i != ERR_SUCCESS )
                      mStopIfError( i );
                     */
				}
			}
		}
		Delay_Ms( 100 );  // ģⵥƬ
		SetUsbSpeed( 1 );  // ĬΪȫ
	}
}



